/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.SHEBANG; break;
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.NORMAL; break;
                                case 5: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.UNIT; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 4: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 4: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 4: state = State.DESCRIPTION; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 246:
                        {
                              Token token = new246(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 247:
                        {
                              Token token = new247(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 248:
                        {
                              Token token = new248(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 249:
                        {
                              Token token = new249(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 250:
                        {
                              Token token = new250(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 251:
                        {
                              Token token = new251(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 252:
                        {
                              Token token = new252(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 253:
                        {
                              Token token = new253(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 254:
                        {
                              Token token = new254(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                                case 3: state = State.PRAGMA; break;
                            }
                            return token;
                        }
                    case 255:
                        {
                              Token token = new255(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 256:
                        {
                              Token token = new256(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 257:
                        {
                              Token token = new257(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 258:
                        {
                              Token token = new258(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 259:
                        {
                              Token token = new259(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 260:
                        {
                              Token token = new260(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 261:
                        {
                              Token token = new261(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 262:
                        {
                              Token token = new262(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 263:
                        {
                              Token token = new263(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 264:
                        {
                              Token token = new264(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 265:
                        {
                              Token token = new265(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 266:
                        {
                              Token token = new266(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 267:
                        {
                              Token token = new267(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 268:
                        {
                              Token token = new268(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 269:
                        {
                              Token token = new269(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 270:
                        {
                              Token token = new270(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 271:
                        {
                              Token token = new271(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new4(  int line,   int pos) { return new TPragmaStart(line, pos); }
    Token new5(  int line,   int pos) { return new TPragmaEnd(line, pos); }
    Token new6(  int line,   int pos) { return new TPragmaUnit(line, pos); }
    Token new7(  int line,   int pos) { return new TNewPragmaUnit(line, pos); }
    Token new8(  int line,   int pos) { return new TIpragmaUnit(line, pos); }
    Token new9(  int line,   int pos) { return new TPragmaUnitAlias(line, pos); }
    Token new10(  int line,   int pos) { return new TPragmaGenerated(line, pos); }
    Token new11(  int line,   int pos) { return new TPragmaSymbolic(line, pos); }
    Token new12(  int line,   int pos) { return new TPragmaLabel(line, pos); }
    Token new13(  int line,   int pos) { return new TPragmaFile(line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TPragmaDescription(text, line, pos); }
    Token new15(  int line,   int pos) { return new TPragmaConversion(line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TPragmaIdOrString(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TPragmaFreeText(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TUnitContent(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TUnitId(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new23(  int line,   int pos) { return new TStar(line, pos); }
    Token new24(  int line,   int pos) { return new TSlash(line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new26(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new27(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new28(  int line,   int pos) { return new TDollar(line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new30(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new32(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new33(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new35(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new39(  int line,   int pos) { return new TComma(line, pos); }
    Token new40(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new41(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new42(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TInsertStartSequence(text, line, pos); }
    Token new44(  int line,   int pos) { return new TDot(line, pos); }
    Token new45(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new46(  String text,   int line,   int pos) { return new TDotPar(text, line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TDivision(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new52(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new54(  String text,   int line,   int pos) { return new TRestrictHeadSequence(text, line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new56(  String text,   int line,   int pos) { return new TDoubleColon(text, line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TAssign(text, line, pos); }
    Token new58(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TLess(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TInsertEndSequence(text, line, pos); }
    Token new63(  String text,   int line,   int pos) { return new TOutputParameters(text, line, pos); }
    Token new64(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new65(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new66(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new67(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new68(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new69(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new70(  String text,   int line,   int pos) { return new TEqual(text, line, pos); }
    Token new71(  String text,   int line,   int pos) { return new TDoubleEqual(text, line, pos); }
    Token new72(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new73(  String text,   int line,   int pos) { return new TGreater(text, line, pos); }
    Token new74(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new75(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new76(  String text,   int line,   int pos) { return new TPartialBijection(text, line, pos); }
    Token new77(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new78(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new79(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new80(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new81(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new82(  int line,   int pos) { return new TAny(line, pos); }
    Token new83(  int line,   int pos) { return new TAssert(line, pos); }
    Token new84(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new85(  int line,   int pos) { return new TBe(line, pos); }
    Token new86(  int line,   int pos) { return new TBegin(line, pos); }
    Token new87(  int line,   int pos) { return new TBool(line, pos); }
    Token new88(  int line,   int pos) { return new TBfalse(line, pos); }
    Token new89(  int line,   int pos) { return new TCase(line, pos); }
    Token new90(  int line,   int pos) { return new TChoice(line, pos); }
    Token new91(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new92(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new93(  int line,   int pos) { return new TConstants(line, pos); }
    Token new94(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new95(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new96(  int line,   int pos) { return new TDo(line, pos); }
    Token new97(  int line,   int pos) { return new TEither(line, pos); }
    Token new98(  int line,   int pos) { return new TElse(line, pos); }
    Token new99(  int line,   int pos) { return new TElsif(line, pos); }
    Token new100(  int line,   int pos) { return new TEnd(line, pos); }
    Token new101(  int line,   int pos) { return new TExtends(line, pos); }
    Token new102(  String text,   int line,   int pos) { return new TFalse(text, line, pos); }
    Token new103(  int line,   int pos) { return new TFin(line, pos); }
    Token new104(  int line,   int pos) { return new TFin1(line, pos); }
    Token new105(  int line,   int pos) { return new TIf(line, pos); }
    Token new106(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new107(  int line,   int pos) { return new TImports(line, pos); }
    Token new108(  int line,   int pos) { return new TIn(line, pos); }
    Token new109(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new110(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new111(  int line,   int pos) { return new TInt(line, pos); }
    Token new112(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new113(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new114(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new115(  int line,   int pos) { return new TLet(line, pos); }
    Token new116(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new117(  int line,   int pos) { return new TMachine(line, pos); }
    Token new118(  int line,   int pos) { return new TModel(line, pos); }
    Token new119(  int line,   int pos) { return new TSystem(line, pos); }
    Token new120(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new121(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new122(  int line,   int pos) { return new TNat(line, pos); }
    Token new123(  int line,   int pos) { return new TNat1(line, pos); }
    Token new124(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new125(  String text,   int line,   int pos) { return new TNatural1(text, line, pos); }
    Token new126(  int line,   int pos) { return new TOf(line, pos); }
    Token new127(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new128(  int line,   int pos) { return new TOr(line, pos); }
    Token new129(  String text,   int line,   int pos) { return new TPi(text, line, pos); }
    Token new130(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new131(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new132(  int line,   int pos) { return new TPre(line, pos); }
    Token new133(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new134(  int line,   int pos) { return new TProperties(line, pos); }
    Token new135(  int line,   int pos) { return new TRefines(line, pos); }
    Token new136(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new137(  int line,   int pos) { return new TSees(line, pos); }
    Token new138(  int line,   int pos) { return new TSelect(line, pos); }
    Token new139(  int line,   int pos) { return new TSets(line, pos); }
    Token new140(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new141(  String text,   int line,   int pos) { return new TSigma(text, line, pos); }
    Token new142(  int line,   int pos) { return new TString(line, pos); }
    Token new143(  int line,   int pos) { return new TThen(line, pos); }
    Token new144(  String text,   int line,   int pos) { return new TTrue(text, line, pos); }
    Token new145(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new146(  int line,   int pos) { return new TUses(line, pos); }
    Token new147(  int line,   int pos) { return new TValue(line, pos); }
    Token new148(  int line,   int pos) { return new TVar(line, pos); }
    Token new149(  int line,   int pos) { return new TVariant(line, pos); }
    Token new150(  int line,   int pos) { return new TVariables(line, pos); }
    Token new151(  int line,   int pos) { return new TWhen(line, pos); }
    Token new152(  int line,   int pos) { return new TWhere(line, pos); }
    Token new153(  int line,   int pos) { return new TWhile(line, pos); }
    Token new154(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new155(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new156(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new157(  String text,   int line,   int pos) { return new TRestrictTailSequence(text, line, pos); }
    Token new158(  String text,   int line,   int pos) { return new TConcatSequence(text, line, pos); }
    Token new159(  int line,   int pos) { return new TArity(line, pos); }
    Token new160(  int line,   int pos) { return new TBin(line, pos); }
    Token new161(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new162(  int line,   int pos) { return new TBtree(line, pos); }
    Token new163(  int line,   int pos) { return new TCard(line, pos); }
    Token new164(  int line,   int pos) { return new TClosure(line, pos); }
    Token new165(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new166(  int line,   int pos) { return new TConc(line, pos); }
    Token new167(  int line,   int pos) { return new TConst(line, pos); }
    Token new168(  int line,   int pos) { return new TDom(line, pos); }
    Token new169(  int line,   int pos) { return new TFather(line, pos); }
    Token new170(  int line,   int pos) { return new TFirst(line, pos); }
    Token new171(  int line,   int pos) { return new TFnc(line, pos); }
    Token new172(  int line,   int pos) { return new TFront(line, pos); }
    Token new173(  int line,   int pos) { return new TId(line, pos); }
    Token new174(  int line,   int pos) { return new TInfix(line, pos); }
    Token new175(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new176(  int line,   int pos) { return new TIseq(line, pos); }
    Token new177(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new178(  int line,   int pos) { return new TIterate(line, pos); }
    Token new179(  int line,   int pos) { return new TLast(line, pos); }
    Token new180(  int line,   int pos) { return new TLeft(line, pos); }
    Token new181(  int line,   int pos) { return new TMax(line, pos); }
    Token new182(  int line,   int pos) { return new TMin(line, pos); }
    Token new183(  int line,   int pos) { return new TMirror(line, pos); }
    Token new184(  int line,   int pos) { return new TMod(line, pos); }
    Token new185(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new186(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new187(  int line,   int pos) { return new TPerm(line, pos); }
    Token new188(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new189(  int line,   int pos) { return new TPred(line, pos); }
    Token new190(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new191(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new192(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new193(  int line,   int pos) { return new TRank(line, pos); }
    Token new194(  int line,   int pos) { return new TRan(line, pos); }
    Token new195(  int line,   int pos) { return new TRec(line, pos); }
    Token new196(  int line,   int pos) { return new TRel(line, pos); }
    Token new197(  int line,   int pos) { return new TRev(line, pos); }
    Token new198(  int line,   int pos) { return new TRight(line, pos); }
    Token new199(  int line,   int pos) { return new TSeq(line, pos); }
    Token new200(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new201(  int line,   int pos) { return new TSizet(line, pos); }
    Token new202(  int line,   int pos) { return new TSize(line, pos); }
    Token new203(  int line,   int pos) { return new TSkip(line, pos); }
    Token new204(  int line,   int pos) { return new TSons(line, pos); }
    Token new205(  int line,   int pos) { return new TSon(line, pos); }
    Token new206(  int line,   int pos) { return new TStruct(line, pos); }
    Token new207(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new208(  int line,   int pos) { return new TSucc(line, pos); }
    Token new209(  int line,   int pos) { return new TTail(line, pos); }
    Token new210(  int line,   int pos) { return new TTop(line, pos); }
    Token new211(  int line,   int pos) { return new TTree(line, pos); }
    Token new212(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new213(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new214(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new215(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new216(  int line,   int pos) { return new TVerticalBar(line, pos); }
    Token new217(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new218(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new219(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new220(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new221(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new222(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new223(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new224(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new225(  int line,   int pos) { return new TKwFreetypes(line, pos); }
    Token new226(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new227(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new228(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new229(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new230(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new231(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new232(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new233(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new234(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new235(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new236(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new237(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new238(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new239(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new240(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new241(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new242(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new243(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new244(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new245(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new246(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new247(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new248(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new249(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new250(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new251(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new252(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new253(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new254(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new255(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new256(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new257(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new258(  int line,   int pos) { return new TTruthPredicate(line, pos); }
    Token new259(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new260(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new261(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new262(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new263(  int line,   int pos) { return new TKwRulesMachine(line, pos); }
    Token new264(  int line,   int pos) { return new TKwRule(line, pos); }
    Token new265(  int line,   int pos) { return new TKwRuleFail(line, pos); }
    Token new266(  int line,   int pos) { return new TKwRuleSuccess(line, pos); }
    Token new267(  int line,   int pos) { return new TKwDependsOnRules(line, pos); }
    Token new268(  int line,   int pos) { return new TKwForAll(line, pos); }
    Token new269(  int line,   int pos) { return new TKwRuleForAll(line, pos); }
    Token new270(  int line,   int pos) { return new TKwExpect(line, pos); }
    Token new271(  int line,   int pos) { return new TKwCounterexample(line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {65, 65, 25}, {66, 66, 26}, {67, 67, 27}, {68, 68, 28}, {69, 69, 29}, {70, 70, 30}, {71, 72, 31}, {73, 73, 32}, {74, 75, 31}, {76, 76, 33}, {77, 77, 34}, {78, 78, 35}, {79, 79, 36}, {80, 80, 37}, {81, 81, 31}, {82, 82, 38}, {83, 83, 39}, {84, 84, 40}, {85, 85, 41}, {86, 86, 42}, {87, 87, 43}, {88, 90, 31}, {91, 91, 44}, {92, 92, 45}, {93, 93, 46}, {94, 94, 47}, {95, 95, 48}, {97, 97, 49}, {98, 98, 50}, {99, 99, 51}, {100, 100, 52}, {101, 101, 53}, {102, 102, 54}, {103, 104, 53}, {105, 105, 55}, {106, 107, 53}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 53}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 53}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {127, 160, 1}, {172, 172, 69}, {183, 183, 70}, {215, 215, 71}, {247, 247, 72}, {955, 955, 73}, {8206, 8207, 1}, {8229, 8229, 74}, {8232, 8233, 1}, {8315, 8315, 75}, {8469, 8469, 76}, {8473, 8473, 77}, {8484, 8484, 78}, {8592, 8592, 79}, {8593, 8593, 80}, {8594, 8594, 81}, {8595, 8595, 82}, {8596, 8596, 83}, {8608, 8608, 84}, {8611, 8611, 85}, {8614, 8614, 86}, {8658, 8658, 87}, {8660, 8660, 88}, {8696, 8696, 89}, {8701, 8701, 90}, {8702, 8702, 91}, {8704, 8704, 92}, {8707, 8707, 93}, {8709, 8709, 94}, {8712, 8712, 95}, {8713, 8713, 96}, {8719, 8719, 97}, {8721, 8721, 98}, {8722, 8722, 99}, {8741, 8741, 100}, {8743, 8743, 101}, {8744, 8744, 102}, {8745, 8745, 103}, {8746, 8746, 104}, {8764, 8764, 105}, {8800, 8800, 106}, {8804, 8804, 107}, {8805, 8805, 108}, {8834, 8834, 109}, {8836, 8836, 110}, {8838, 8838, 111}, {8840, 8840, 112}, {8855, 8855, 113}, {8868, 8868, 114}, {8869, 8869, 115}, {8898, 8898, 116}, {8899, 8899, 117}, {8918, 8918, 118}, {8978, 8978, 119}, {9654, 9654, 120}, {9655, 9655, 121}, {9664, 9664, 122}, {9665, 9665, 123}, {10496, 10496, 124}, {10516, 10516, 125}, {10518, 10518, 126}, {10852, 10852, 127}, {10853, 10853, 128}, {57600, 57600, 129}, {57601, 57601, 130}, {57602, 57602, 131}, {57603, 57603, 132}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 33, 133}, {34, 34, 134}, {35, 65535, 133}, },
            {{33, 33, 135}, {65, 65, 136}, {67, 67, 137}, {68, 68, 138}, {69, 69, 139}, {70, 70, 140}, {73, 73, 141}, {76, 76, 142}, {79, 79, 143}, {80, 80, 144}, {83, 83, 145}, {85, 85, 146}, {86, 86, 147}, {108, 108, 148}, {112, 112, 149}, {116, 116, 150}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 151}, },
            {{45, 45, 152}, {8722, 8722, 153}, },
            {},
            {{45, 45, 154}, {62, 62, 155}, {8722, 8722, 156}, },
            {{0, 9, 157}, {10, 10, 158}, {11, 12, 157}, {13, 13, 158}, {14, 32, 157}, {40, 40, 159}, {46, 46, 160}, {127, 160, 157}, {8206, 8207, 157}, {8232, 8233, 157}, },
            {{42, 42, 161}, {47, 47, 162}, {58, 58, 163}, {60, 60, 164}, {61, 61, 165}, {92, 92, 166}, {124, 124, 167}, },
            {{48, 57, 19}, {120, 120, 168}, },
            {{48, 57, 19}, },
            {{58, 58, 169}, {61, 61, 170}, {8712, 8712, 171}, },
            {},
            {{43, 43, 172}, {45, 45, 173}, {58, 58, 174}, {60, 60, 175}, {61, 61, 176}, {124, 124, 177}, {8722, 8722, 178}, },
            {{61, 61, 179}, {62, 62, 180}, },
            {{43, 43, 181}, {45, 45, 182}, {60, 60, 183}, {61, 61, 184}, {8722, 8722, 185}, },
            {{48, 57, 186}, {65, 65, 187}, {66, 66, 188}, {67, 77, 187}, {78, 78, 189}, {79, 82, 187}, {83, 83, 190}, {84, 90, 187}, {95, 95, 191}, {97, 122, 192}, },
            {{48, 57, 186}, {65, 68, 187}, {69, 69, 193}, {70, 78, 187}, {79, 79, 194}, {80, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 65, 195}, {66, 71, 187}, {72, 72, 196}, {73, 78, 187}, {79, 79, 197}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 198}, {70, 78, 187}, {79, 79, 199}, {80, 122, -28}, },
            {{48, 57, 186}, {65, 72, 187}, {73, 73, 200}, {74, 75, 187}, {76, 76, 201}, {77, 77, 187}, {78, 78, 202}, {79, 85, 187}, {86, 86, 203}, {87, 87, 187}, {88, 88, 204}, {89, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 65, 205}, {66, 72, 187}, {73, 73, 206}, {74, 78, 187}, {79, 79, 207}, {80, 81, 187}, {82, 82, 208}, {83, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 69, 187}, {70, 70, 209}, {71, 76, 187}, {77, 77, 210}, {78, 78, 211}, {79, 90, 187}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 212}, {70, 78, 187}, {79, 79, 213}, {80, 122, -28}, },
            {{48, 57, 186}, {65, 65, 214}, {66, 72, 187}, {73, 73, 215}, {74, 78, 187}, {79, 79, 216}, {80, 122, -28}, },
            {{48, 57, 186}, {65, 65, 217}, {66, 90, 187}, {95, 122, -27}, },
            {{48, 69, -34}, {70, 70, 218}, {71, 79, 187}, {80, 80, 219}, {81, 81, 187}, {82, 82, 220}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 221}, {74, 78, 187}, {79, 79, 222}, {80, 81, 187}, {82, 82, 223}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 224}, {70, 84, 187}, {85, 85, 225}, {86, 90, 187}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 226}, {70, 72, 187}, {73, 73, 227}, {74, 83, 187}, {84, 84, 228}, {85, 88, 187}, {89, 89, 229}, {90, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 71, 187}, {72, 72, 230}, {73, 81, 187}, {82, 82, 231}, {83, 122, -32}, },
            {{48, 57, 186}, {65, 77, 187}, {78, 78, 232}, {79, 82, 187}, {83, 83, 233}, {84, 122, -27}, },
            {{48, 57, 186}, {65, 65, 234}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 235}, {73, 90, 187}, {95, 122, -27}, },
            {},
            {{47, 47, 236}, {124, 124, 237}, },
            {},
            {},
            {},
            {{48, 95, -33}, {97, 113, 192}, {114, 114, 238}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 101, 192}, {102, 102, 239}, {103, 104, 192}, {105, 105, 240}, {106, 110, 192}, {111, 111, 241}, {112, 115, 192}, {116, 116, 242}, {117, 122, 192}, },
            {{48, 95, -33}, {97, 97, 243}, {98, 107, 192}, {108, 108, 244}, {109, 110, 192}, {111, 111, 245}, {112, 122, 192}, },
            {{48, 95, -33}, {97, 110, 192}, {111, 111, 246}, {112, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 97, 247}, {98, 104, 192}, {105, 105, 248}, {106, 109, 192}, {110, 110, 249}, {111, 113, 192}, {114, 114, 250}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 99, 192}, {100, 100, 251}, {101, 109, 192}, {110, 110, 252}, {111, 114, 192}, {115, 115, 253}, {116, 116, 254}, {117, 122, 192}, },
            {{48, 95, -33}, {97, 97, 255}, {98, 100, 192}, {101, 101, 256}, {102, 122, 192}, },
            {{48, 95, -33}, {97, 97, 257}, {98, 104, 192}, {105, 105, 258}, {106, 110, 192}, {111, 111, 259}, {112, 122, 192}, },
            {{48, 110, -54}, {111, 111, 260}, {112, 122, 192}, },
            {{48, 113, -51}, {114, 114, 261}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 100, 192}, {101, 101, 262}, {102, 110, 192}, {111, 111, 263}, {112, 113, 192}, {114, 114, 264}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 97, 265}, {98, 100, 192}, {101, 101, 266}, {102, 104, 192}, {105, 105, 267}, {106, 122, 192}, },
            {{48, 100, -62}, {101, 101, 268}, {102, 104, 192}, {105, 105, 269}, {106, 106, 192}, {107, 107, 270}, {108, 110, 192}, {111, 111, 271}, {112, 115, 192}, {116, 116, 272}, {117, 117, 273}, {118, 122, 192}, },
            {{48, 95, -33}, {97, 97, 274}, {98, 110, 192}, {111, 111, 275}, {112, 113, 192}, {114, 114, 276}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 109, 192}, {110, 110, 277}, {111, 122, 192}, },
            {},
            {{45, 45, 278}, {62, 62, 279}, {124, 124, 280}, },
            {},
            {},
            {},
            {{0, 9, 281}, {10, 10, 282}, {11, 12, 281}, {13, 13, 282}, {14, 32, 281}, {40, 40, 283}, {127, 160, 281}, {8206, 8207, 281}, {8232, 8233, 281}, },
            {},
            {},
            {},
            {},
            {{185, 185, 284}, },
            {{49, 49, 285}, {8321, 8321, 286}, },
            {{49, 49, 287}, {8321, 8321, 288}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{45, 8722, -17}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {},
            {{66, 66, 289}, {83, 83, 290}, },
            {{79, 79, 291}, },
            {{69, 69, 292}, },
            {{88, 88, 293}, },
            {{79, 79, 294}, },
            {{77, 77, 295}, {78, 78, 296}, },
            {{79, 79, 297}, },
            {{80, 80, 298}, },
            {{82, 82, 299}, },
            {{69, 69, 300}, {85, 85, 301}, },
            {{83, 83, 302}, },
            {{65, 65, 303}, },
            {{105, 105, 304}, },
            {{114, 114, 305}, },
            {{114, 114, 306}, },
            {},
            {{62, 62, 307}, },
            {{62, 62, 307}, },
            {{62, 62, 308}, },
            {},
            {{62, 62, 308}, },
            {{0, 40, -18}, {127, 8233, -18}, },
            {{0, 8233, -159}, },
            {},
            {},
            {{64, 64, 309}, },
            {{0, 9, 310}, {10, 10, 311}, {11, 12, 310}, {13, 13, 311}, {14, 65535, 310}, },
            {},
            {{58, 58, 312}, {60, 60, 313}, },
            {},
            {},
            {{92, 92, 314}, },
            {{48, 57, 315}, {65, 70, 315}, {97, 102, 315}, },
            {},
            {},
            {},
            {},
            {{45, 45, 316}, {62, 62, 317}, },
            {},
            {{45, 45, 318}, {58, 58, 319}, {124, 124, 320}, {8722, 8722, 321}, },
            {{62, 62, 322}, },
            {},
            {{62, 62, 317}, },
            {},
            {},
            {{62, 62, 323}, },
            {{62, 62, 324}, },
            {},
            {},
            {{62, 62, 324}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 82, 187}, {83, 83, 325}, {84, 122, -27}, },
            {{48, 57, 186}, {65, 88, 187}, {89, 89, 326}, {90, 122, -41}, },
            {{48, 82, -190}, {83, 83, 327}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 70, 187}, {71, 71, 328}, {72, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 78, 187}, {79, 79, 329}, {80, 122, -28}, },
            {{48, 82, -190}, {83, 83, 330}, {84, 122, -27}, },
            {{48, 78, -196}, {79, 79, 331}, {80, 122, -28}, },
            {{48, 77, -43}, {78, 78, 332}, {79, 84, 187}, {85, 85, 333}, {86, 122, -40}, },
            {{48, 69, -34}, {70, 70, 334}, {71, 79, 187}, {80, 80, 335}, {81, 90, 187}, {95, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 83, 187}, {84, 84, 336}, {85, 90, 187}, {95, 122, -27}, },
            {{48, 82, -190}, {83, 83, 337}, {84, 122, -27}, },
            {{48, 57, 186}, {65, 67, 187}, {68, 68, 338}, {69, 90, 187}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 339}, {70, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 79, 187}, {80, 80, 340}, {81, 83, 187}, {84, 84, 341}, {85, 122, -202}, },
            {{48, 57, 186}, {65, 75, 187}, {76, 76, 342}, {77, 90, 187}, {95, 122, -27}, },
            {{48, 77, -43}, {78, 78, 343}, {79, 122, -34}, },
            {{48, 57, 186}, {65, 81, 187}, {82, 82, 344}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 345}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 79, -206}, {80, 80, 346}, {81, 122, -200}, },
            {{48, 57, 186}, {65, 66, 187}, {67, 67, 347}, {68, 72, 187}, {73, 73, 348}, {74, 83, 187}, {84, 84, 349}, {85, 85, 187}, {86, 86, 350}, {87, 90, 187}, {95, 122, -27}, },
            {{48, 83, -202}, {84, 84, 351}, {85, 122, -202}, },
            {{48, 66, -213}, {67, 67, 352}, {68, 90, 187}, {95, 122, -27}, },
            {{48, 66, -213}, {67, 67, 353}, {68, 87, 187}, {88, 88, 354}, {89, 122, -31}, },
            {{48, 77, -43}, {78, 78, 355}, {79, 122, -34}, },
            {{48, 67, -204}, {68, 68, 356}, {69, 122, -204}, },
            {{48, 83, -202}, {84, 84, 357}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 358}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 86, 187}, {87, 87, 359}, {88, 90, 187}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 360}, {70, 78, 187}, {79, 79, 361}, {80, 122, -28}, },
            {{48, 69, -34}, {70, 70, 362}, {71, 90, 187}, {95, 122, -27}, },
            {{48, 75, -207}, {76, 76, 363}, {77, 122, -207}, },
            {{48, 68, -28}, {69, 69, 364}, {70, 75, 187}, {76, 76, 365}, {77, 83, 187}, {84, 84, 366}, {85, 122, -202}, },
            {{48, 70, -195}, {71, 71, 367}, {72, 122, -195}, },
            {{48, 81, -209}, {82, 82, 368}, {83, 122, -32}, },
            {{48, 82, -190}, {83, 83, 369}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 370}, {70, 122, -205}, },
            {{48, 57, 186}, {65, 84, 187}, {85, 85, 371}, {86, 122, -40}, },
            {{48, 72, -31}, {73, 73, 372}, {74, 90, 187}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 373}, {70, 122, -205}, },
            {{48, 75, -207}, {76, 76, 374}, {77, 81, 187}, {82, 82, 375}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 376}, {70, 72, 187}, {73, 73, 377}, {74, 122, -234}, },
            {},
            {{47, 47, 378}, },
            {{48, 95, -33}, {97, 104, 192}, {105, 105, 379}, {106, 122, 192}, },
            {{48, 95, -33}, {97, 97, 380}, {98, 122, 192}, },
            {{48, 109, -66}, {110, 110, 381}, {111, 122, 192}, },
            {{48, 110, -54}, {111, 111, 382}, {112, 122, 192}, },
            {{48, 113, -51}, {114, 114, 383}, {115, 122, 192}, },
            {{48, 113, -51}, {114, 114, 384}, {115, 122, 192}, },
            {{48, 110, -54}, {111, 111, 385}, {112, 122, 192}, },
            {{48, 109, -66}, {110, 110, 386}, {111, 122, 192}, },
            {{48, 95, -33}, {97, 108, 192}, {109, 109, 387}, {110, 122, 192}, },
            {{48, 95, -33}, {97, 115, 192}, {116, 116, 388}, {117, 122, 192}, },
            {{48, 113, -51}, {114, 114, 389}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 98, 192}, {99, 99, 390}, {100, 122, 192}, },
            {{48, 110, -54}, {111, 111, 391}, {112, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 392}, {103, 115, 192}, {116, 116, 393}, {117, 122, 192}, },
            {{48, 100, -62}, {101, 101, 394}, {102, 122, 192}, },
            {{48, 100, -62}, {101, 101, 395}, {102, 122, 192}, },
            {{48, 95, -33}, {97, 114, 192}, {115, 115, 396}, {116, 122, 192}, },
            {{48, 101, -52}, {102, 102, 397}, {103, 122, 192}, },
            {{48, 95, -33}, {97, 119, 192}, {120, 120, 398}, {121, 122, 192}, },
            {{48, 109, -66}, {110, 110, 399}, {111, 113, 192}, {114, 114, 400}, {115, 122, 192}, },
            {{48, 99, -57}, {100, 100, 401}, {101, 122, 192}, },
            {{48, 115, -249}, {116, 116, 402}, {117, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 403}, {115, 122, 192}, },
            {{48, 114, -257}, {115, 115, 404}, {116, 122, 192}, },
            {{48, 100, -62}, {101, 101, 405}, {102, 105, 192}, {106, 106, 406}, {107, 122, 192}, },
            {{48, 109, -66}, {110, 110, 407}, {111, 122, 192}, },
            {{48, 98, -251}, {99, 99, 408}, {100, 107, 192}, {108, 108, 409}, {109, 117, 192}, {118, 118, 410}, {119, 122, 192}, },
            {{48, 95, -33}, {97, 102, 192}, {103, 103, 411}, {104, 122, 192}, },
            {{48, 95, -33}, {97, 112, 192}, {113, 113, 412}, {114, 122, 192}, },
            {{48, 95, -33}, {97, 121, 192}, {122, 122, 413}, },
            {{48, 104, -240}, {105, 105, 414}, {106, 122, 192}, },
            {{48, 109, -66}, {110, 110, 415}, {111, 122, 192}, },
            {{48, 113, -51}, {114, 114, 416}, {115, 122, 192}, },
            {{48, 95, -33}, {97, 97, 192}, {98, 98, 417}, {99, 99, 418}, {100, 122, 192}, },
            {{48, 104, -240}, {105, 105, 419}, {106, 122, 192}, },
            {{48, 95, -33}, {97, 111, 192}, {112, 112, 420}, {113, 122, 192}, },
            {{48, 100, -62}, {101, 101, 421}, {102, 122, 192}, },
            {{48, 104, -240}, {105, 105, 422}, {106, 122, 192}, },
            {{62, 62, 423}, },
            {{62, 62, 424}, },
            {},
            {{0, 8233, -72}, },
            {{0, 8233, -72}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{83, 83, 425}, },
            {{83, 83, 426}, },
            {{78, 78, 427}, },
            {{70, 70, 428}, },
            {{80, 80, 429}, {84, 84, 430}, },
            {{82, 82, 431}, },
            {{80, 80, 432}, },
            {{67, 67, 433}, {73, 73, 434}, {86, 86, 435}, },
            {{67, 67, 436}, },
            {{69, 69, 437}, {80, 80, 438}, },
            {{69, 69, 439}, {79, 79, 440}, },
            {{69, 69, 441}, {84, 84, 442}, },
            {{66, 66, 443}, },
            {{69, 69, 444}, },
            {{76, 76, 445}, {82, 82, 446}, },
            {{116, 116, 447}, },
            {{101, 101, 448}, },
            {{117, 117, 449}, },
            {{62, 62, 450}, },
            {{62, 62, 451}, },
            {},
            {{0, 65535, -164}, },
            {},
            {},
            {{58, 58, 452}, },
            {},
            {{48, 102, -170}, },
            {},
            {{62, 62, 453}, },
            {{62, 62, 454}, },
            {},
            {},
            {{62, 62, 454}, },
            {},
            {{62, 62, 455}, },
            {{62, 62, 456}, },
            {{48, 83, -202}, {84, 84, 457}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 458}, {70, 122, -205}, },
            {{48, 72, -31}, {73, 73, 459}, {74, 122, -234}, },
            {{48, 75, -207}, {76, 76, 460}, {77, 122, -207}, },
            {{48, 68, -28}, {69, 69, 461}, {70, 122, -205}, },
            {{48, 72, -31}, {73, 73, 462}, {74, 122, -234}, },
            {{48, 66, -213}, {67, 67, 463}, {68, 82, 187}, {83, 83, 464}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 465}, {79, 122, -34}, },
            {{48, 72, -31}, {73, 73, 466}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 467}, {70, 122, -205}, },
            {{48, 71, -42}, {72, 72, 468}, {73, 122, -45}, },
            {{48, 68, -28}, {69, 69, 469}, {70, 72, 187}, {73, 73, 470}, {74, 122, -234}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 471}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 472}, {70, 122, -205}, },
            {{48, 68, -28}, {69, 69, 473}, {70, 122, -205}, },
            {{48, 82, -190}, {83, 83, 474}, {84, 122, -27}, },
            {{48, 48, 186}, {49, 49, 475}, {50, 57, 186}, {65, 122, -33}, },
            {{48, 57, 186}, {65, 65, 476}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 477}, {70, 122, -205}, },
            {{48, 75, -207}, {76, 76, 478}, {77, 78, 187}, {79, 79, 479}, {80, 122, -28}, },
            {{48, 75, -207}, {76, 76, 480}, {77, 122, -207}, },
            {{48, 83, -202}, {84, 84, 481}, {85, 122, -202}, },
            {{48, 68, -28}, {69, 69, 482}, {70, 122, -205}, },
            {{48, 57, 186}, {65, 65, 483}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 65, 484}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 485}, {73, 122, -45}, },
            {{48, 72, -31}, {73, 73, 486}, {74, 122, -234}, },
            {{48, 72, -31}, {73, 73, 487}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 488}, {70, 122, -205}, },
            {{48, 48, 186}, {49, 49, 489}, {50, 57, 186}, {65, 84, 187}, {85, 85, 490}, {86, 122, -40}, },
            {{48, 81, -209}, {82, 82, 491}, {83, 122, -32}, },
            {{48, 48, 186}, {49, 49, 492}, {50, 122, -345}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 76, 187}, {77, 77, 493}, {78, 79, 187}, {80, 80, 494}, {81, 122, -200}, },
            {{48, 72, -31}, {73, 73, 495}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 496}, {70, 122, -205}, },
            {{48, 82, -190}, {83, 83, 497}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 498}, {70, 122, -205}, },
            {{48, 82, -190}, {83, 83, 499}, {84, 122, -27}, },
            {{48, 76, -363}, {77, 77, 500}, {78, 90, 187}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 501}, {74, 122, -234}, },
            {{48, 83, -202}, {84, 84, 502}, {85, 122, -202}, },
            {{48, 77, -43}, {78, 78, 503}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 504}, {70, 122, -205}, },
            {{48, 78, -196}, {79, 79, 505}, {80, 122, -28}, },
            {{48, 82, -190}, {83, 83, 506}, {84, 122, -27}, },
            {{48, 84, -233}, {85, 85, 507}, {86, 122, -40}, },
            {{48, 72, -31}, {73, 73, 508}, {74, 122, -234}, },
            {{48, 77, -43}, {78, 78, 509}, {79, 81, 187}, {82, 82, 510}, {83, 122, -32}, },
            {{48, 75, -207}, {76, 76, 511}, {77, 122, -207}, },
            {},
            {{48, 115, -249}, {116, 116, 512}, {117, 122, 192}, },
            {{48, 95, -33}, {97, 107, 192}, {108, 108, 513}, {109, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 107, -382}, {108, 108, 514}, {109, 122, 192}, },
            {{48, 100, -62}, {101, 101, 515}, {102, 122, 192}, },
            {{48, 99, -57}, {100, 100, 516}, {101, 122, 192}, },
            {{48, 114, -257}, {115, 115, 517}, {116, 122, 192}, },
            {{48, 98, -251}, {99, 99, 518}, {100, 114, 192}, {115, 115, 519}, {116, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 103, 192}, {104, 104, 520}, {105, 122, 192}, },
            {{48, 114, -257}, {115, 115, 521}, {116, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 522}, {111, 122, 192}, },
            {{48, 104, -240}, {105, 105, 523}, {106, 122, 192}, },
            {{48, 100, -62}, {101, 101, 524}, {102, 122, 192}, },
            {{48, 112, -270}, {113, 113, 525}, {114, 122, 192}, },
            {{48, 113, -51}, {114, 114, 526}, {115, 122, 192}, },
            {{48, 115, -249}, {116, 116, 527}, {117, 122, 192}, },
            {{48, 115, -249}, {116, 116, 528}, {117, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 529}, {115, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 108, -248}, {109, 109, 530}, {110, 122, 192}, },
            {{48, 115, -249}, {116, 116, 531}, {117, 122, 192}, },
            {{48, 99, -57}, {100, 100, 532}, {101, 101, 192}, {102, 102, 533}, {103, 122, 192}, },
            {{48, 48, 186}, {49, 49, 534}, {50, 50, 535}, {51, 57, 186}, {65, 122, -33}, },
            {{48, 95, -33}, {97, 106, 192}, {107, 107, 536}, {108, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 103, -390}, {104, 104, 537}, {105, 122, 192}, },
            {{48, 48, 186}, {49, 49, 538}, {50, 122, -345}, },
            {{48, 100, -62}, {101, 101, 539}, {102, 122, 192}, },
            {{48, 111, -277}, {112, 112, 540}, {113, 122, 192}, },
            {{48, 114, -257}, {115, 115, 541}, {116, 122, 192}, },
            {{48, 95, -33}, {97, 116, 192}, {117, 117, 542}, {118, 122, 192}, },
            {{48, 115, -249}, {116, 116, 543}, {117, 122, 192}, },
            {{48, 98, -251}, {99, 99, 544}, {100, 122, 192}, },
            {{48, 107, -382}, {108, 108, 545}, {109, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 546}, {102, 122, 192}, },
            {{48, 110, -54}, {111, 111, 547}, {112, 122, 192}, },
            {},
            {},
            {{84, 84, 548}, },
            {{69, 69, 549}, },
            {{67, 67, 550}, {83, 83, 551}, },
            {{73, 73, 552}, },
            {{82, 82, 553}, },
            {{69, 69, 554}, },
            {{77, 77, 555}, },
            {{79, 79, 556}, },
            {{76, 76, 557}, },
            {{84, 84, 558}, },
            {{65, 65, 559}, },
            {{65, 65, 560}, },
            {{82, 82, 561}, },
            {{65, 65, 562}, },
            {{68, 68, 563}, },
            {{77, 77, 564}, {80, 80, 565}, },
            {{83, 83, 566}, },
            {{83, 83, 567}, },
            {{83, 83, 568}, },
            {{83, 83, 569}, },
            {{85, 85, 570}, },
            {{73, 73, 571}, },
            {{101, 101, 572}, },
            {{100, 100, 573}, },
            {{116, 116, 574}, },
            {},
            {},
            {},
            {},
            {{62, 62, 575}, },
            {},
            {},
            {{48, 81, -209}, {82, 82, 576}, {83, 122, -32}, },
            {{48, 81, -209}, {82, 82, 577}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 578}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 66, -213}, {67, 67, 579}, {68, 122, -215}, },
            {{48, 81, -209}, {82, 82, 580}, {83, 122, -32}, },
            {{48, 83, -202}, {84, 84, 581}, {85, 122, -202}, },
            {{48, 83, -202}, {84, 84, 582}, {85, 122, -202}, },
            {{48, 77, -43}, {78, 78, 583}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 584}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 585}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 69, -34}, {70, 70, 586}, {71, 122, -226}, },
            {{48, 83, -202}, {84, 84, 587}, {85, 122, -202}, },
            {{48, 66, -213}, {67, 67, 588}, {68, 122, -215}, },
            {{48, 77, -43}, {78, 78, 589}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 590}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 75, -207}, {76, 76, 591}, {77, 122, -207}, },
            {{48, 83, -202}, {84, 84, 592}, {85, 122, -202}, },
            {{48, 68, -28}, {69, 69, 593}, {70, 122, -205}, },
            {{48, 81, -209}, {82, 82, 594}, {83, 122, -32}, },
            {{48, 84, -233}, {85, 85, 595}, {86, 122, -40}, },
            {{48, 72, -31}, {73, 73, 596}, {74, 122, -234}, },
            {{48, 70, -195}, {71, 71, 597}, {72, 81, 187}, {82, 82, 598}, {83, 122, -32}, },
            {{48, 81, -209}, {82, 82, 599}, {83, 122, -32}, },
            {{48, 75, -207}, {76, 76, 600}, {77, 122, -207}, },
            {{48, 72, -31}, {73, 73, 601}, {74, 122, -234}, },
            {{48, 77, -43}, {78, 78, 602}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 603}, {79, 122, -34}, },
            {{48, 75, -207}, {76, 76, 604}, {77, 122, -207}, },
            {{48, 122, -33}, },
            {{48, 81, -209}, {82, 82, 605}, {83, 122, -32}, },
            {{48, 57, 186}, {65, 65, 606}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -196}, {79, 79, 607}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 608}, {70, 122, -205}, },
            {{48, 77, -43}, {78, 78, 609}, {79, 122, -34}, },
            {{48, 82, -190}, {83, 83, 610}, {84, 90, 187}, {95, 95, 611}, {97, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 66, -213}, {67, 67, 612}, {68, 122, -215}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 65, 613}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 614}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 615}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 616}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 617}, {70, 122, -205}, },
            {{48, 57, 186}, {65, 65, 618}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 619}, {70, 122, -205}, },
            {{48, 68, -28}, {69, 69, 620}, {70, 122, -205}, },
            {{48, 95, -33}, {97, 120, 192}, {121, 121, 621}, {122, 122, 192}, },
            {{48, 114, -257}, {115, 115, 622}, {116, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 623}, {102, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 116, -418}, {117, 117, 624}, {118, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 115, -249}, {116, 116, 625}, {117, 122, 192}, },
            {{48, 100, -62}, {101, 101, 626}, {102, 122, 192}, },
            {{48, 115, -249}, {116, 116, 627}, {117, 122, 192}, },
            {{48, 115, -249}, {116, 116, 628}, {117, 122, 192}, },
            {{48, 119, -259}, {120, 120, 629}, {121, 122, 192}, },
            {{48, 113, -51}, {114, 114, 630}, {115, 122, 192}, },
            {{48, 48, 186}, {49, 49, 631}, {50, 122, -345}, },
            {{48, 95, -33}, {97, 97, 632}, {98, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 110, -54}, {111, 111, 633}, {112, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 634}, {103, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 104, -240}, {105, 105, 635}, {106, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -249}, {116, 116, 636}, {117, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 115, -249}, {116, 116, 637}, {117, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 98, -251}, {99, 99, 638}, {100, 122, 192}, },
            {{48, 113, -51}, {114, 114, 639}, {115, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 640}, {111, 122, 192}, },
            {{82, 82, 641}, },
            {{82, 82, 642}, },
            {{82, 82, 643}, },
            {{84, 84, 644}, },
            {{78, 78, 645}, },
            {{69, 69, 646}, },
            {{78, 78, 647}, },
            {{85, 85, 648}, },
            {{82, 82, 649}, },
            {{85, 85, 650}, },
            {{73, 73, 651}, },
            {{82, 82, 652}, },
            {{76, 76, 653}, },
            {{65, 65, 654}, },
            {{84, 84, 655}, },
            {{73, 73, 656}, },
            {{79, 79, 657}, },
            {{69, 69, 658}, },
            {},
            {},
            {{84, 84, 659}, },
            {},
            {{69, 69, 660}, },
            {{65, 65, 661}, },
            {{114, 114, 662}, },
            {{105, 105, 663}, },
            {{104, 104, 664}, },
            {},
            {{48, 57, 186}, {65, 65, 665}, {66, 122, -37}, },
            {{48, 83, -202}, {84, 84, 666}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 667}, {70, 122, -205}, },
            {{48, 68, -28}, {69, 69, 668}, {70, 122, -205}, },
            {{48, 57, 186}, {65, 65, 669}, {66, 81, 187}, {82, 82, 670}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 671}, {70, 122, -205}, },
            {{48, 72, -31}, {73, 73, 672}, {74, 122, -234}, },
            {{48, 67, -204}, {68, 68, 673}, {69, 122, -204}, },
            {{48, 81, -209}, {82, 82, 674}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 675}, {84, 122, -27}, },
            {{48, 83, -202}, {84, 84, 676}, {85, 122, -202}, },
            {{48, 67, -204}, {68, 68, 677}, {69, 122, -204}, },
            {{48, 122, -33}, },
            {{48, 75, -207}, {76, 76, 678}, {77, 122, -207}, },
            {{48, 88, -191}, {89, 89, 679}, {90, 122, -41}, },
            {{48, 76, -363}, {77, 77, 680}, {78, 122, -369}, },
            {{48, 83, -202}, {84, 84, 681}, {85, 122, -202}, },
            {{48, 67, -204}, {68, 68, 682}, {69, 122, -204}, },
            {{48, 57, 186}, {65, 65, 683}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 684}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 685}, {74, 122, -234}, },
            {{48, 90, -33}, {95, 95, 686}, {97, 122, 192}, },
            {{48, 77, -43}, {78, 78, 687}, {79, 122, -34}, },
            {{48, 83, -202}, {84, 84, 688}, {85, 122, -202}, },
            {{48, 83, -202}, {84, 84, 689}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 65, 690}, {66, 122, -37}, },
            {{48, 83, -202}, {84, 84, 691}, {85, 122, -202}, },
            {{48, 83, -202}, {84, 84, 692}, {85, 122, -202}, },
            {{48, 81, -209}, {82, 82, 693}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 694}, {70, 122, -205}, },
            {{48, 90, -33}, {95, 95, 695}, {97, 122, 192}, },
            {{48, 69, -34}, {70, 70, 696}, {71, 82, 187}, {83, 83, 697}, {84, 122, -27}, },
            {{48, 83, -202}, {84, 84, 698}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 70, -195}, {71, 71, 699}, {72, 122, -195}, },
            {{48, 76, -363}, {77, 77, 700}, {78, 122, -369}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 701}, {84, 122, -27}, },
            {{48, 65, -27}, {66, 66, 702}, {67, 77, 187}, {78, 78, 703}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 704}, {102, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 705}, {115, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 706}, {115, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -249}, {116, 116, 707}, {117, 122, 192}, },
            {{48, 113, -51}, {114, 114, 708}, {115, 122, 192}, },
            {{48, 104, -240}, {105, 105, 709}, {106, 122, 192}, },
            {{48, 119, -259}, {120, 120, 710}, {121, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -249}, {116, 116, 711}, {117, 122, 192}, },
            {{48, 100, -62}, {101, 101, 712}, {102, 122, 192}, },
            {{48, 122, -33}, },
            {{65, 65, 713}, },
            {{84, 84, 714}, },
            {{69, 69, 715}, },
            {{65, 65, 716}, {82, 82, 717}, },
            {{73, 73, 718}, },
            {{83, 83, 719}, },
            {{68, 68, 720}, },
            {{76, 76, 721}, },
            {{84, 84, 722}, },
            {{68, 68, 723}, },
            {{65, 65, 724}, },
            {{73, 73, 725}, },
            {{95, 95, 726}, },
            {{84, 84, 727}, },
            {{84, 84, 728}, },
            {{67, 67, 729}, },
            {{84, 84, 730}, },
            {{82, 82, 731}, },
            {{73, 73, 732}, },
            {{83, 83, 733}, },
            {{66, 66, 734}, },
            {{97, 97, 735}, },
            {{99, 99, 736}, },
            {{95, 95, 737}, },
            {{48, 66, -213}, {67, 67, 738}, {68, 122, -215}, },
            {{48, 72, -31}, {73, 73, 739}, {74, 122, -234}, },
            {{48, 122, -33}, },
            {{48, 83, -202}, {84, 84, 740}, {85, 122, -202}, },
            {{48, 77, -43}, {78, 78, 741}, {79, 122, -34}, },
            {{48, 57, 186}, {65, 65, 742}, {66, 122, -37}, },
            {{48, 81, -209}, {82, 82, 743}, {83, 122, -32}, },
            {{48, 83, -202}, {84, 84, 744}, {85, 122, -202}, },
            {{48, 82, -190}, {83, 83, 745}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 746}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 79, -206}, {80, 80, 747}, {81, 122, -200}, },
            {{48, 68, -28}, {69, 69, 748}, {70, 122, -205}, },
            {{48, 82, -190}, {83, 83, 749}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 750}, {70, 122, -205}, },
            {{48, 75, -207}, {76, 76, 751}, {77, 122, -207}, },
            {{48, 81, -209}, {82, 82, 752}, {83, 122, -32}, },
            {{48, 57, 186}, {65, 65, 753}, {66, 122, -37}, },
            {{48, 78, -196}, {79, 79, 754}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 755}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -207}, {76, 76, 756}, {77, 122, -207}, },
            {{48, 72, -31}, {73, 73, 757}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 758}, {70, 122, -205}, },
            {{48, 83, -202}, {84, 84, 759}, {85, 122, -202}, },
            {{48, 76, -363}, {77, 77, 760}, {78, 82, 187}, {83, 83, 761}, {84, 122, -27}, },
            {{48, 76, -363}, {77, 77, 762}, {78, 122, -369}, },
            {{48, 57, 186}, {65, 65, 763}, {66, 78, 187}, {79, 79, 764}, {80, 122, -28}, },
            {{48, 84, -233}, {85, 85, 765}, {86, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -207}, {76, 76, 766}, {77, 122, -207}, },
            {{48, 83, -202}, {84, 84, 767}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 768}, {102, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 769}, {102, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 119, -259}, {120, 120, 770}, {121, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 771}, {102, 122, 192}, },
            {{67, 67, 772}, },
            {{73, 73, 773}, },
            {{84, 84, 774}, },
            {{78, 78, 775}, },
            {{65, 65, 776}, },
            {{84, 84, 777}, },
            {{83, 83, 778}, },
            {{83, 83, 779}, },
            {{65, 65, 780}, },
            {{83, 83, 781}, },
            {{69, 69, 782}, },
            {{76, 76, 783}, },
            {{65, 65, 784}, },
            {{79, 79, 785}, },
            {{73, 73, 786}, },
            {{69, 69, 787}, },
            {{65, 65, 788}, },
            {{69, 69, 789}, },
            {{84, 84, 790}, },
            {{84, 84, 791}, },
            {},
            {{76, 76, 792}, },
            {{108, 108, 793}, },
            {{97, 97, 794}, },
            {{112, 112, 795}, },
            {{48, 83, -202}, {84, 84, 796}, {85, 122, -202}, },
            {{48, 78, -196}, {79, 79, 797}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 798}, {70, 122, -205}, },
            {{48, 83, -202}, {84, 84, 799}, {85, 122, -202}, },
            {{48, 72, -31}, {73, 73, 800}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 801}, {70, 122, -205}, },
            {{48, 72, -31}, {73, 73, 802}, {74, 122, -234}, },
            {{48, 90, -33}, {95, 95, 803}, {97, 122, 192}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 804}, {70, 122, -205}, },
            {{48, 77, -43}, {78, 78, 805}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 806}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 807}, {74, 122, -234}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 808}, {79, 122, -34}, },
            {{48, 79, -206}, {80, 80, 809}, {81, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 48, 186}, {49, 49, 810}, {50, 122, -345}, },
            {{48, 78, -196}, {79, 79, 811}, {80, 122, -28}, },
            {{48, 82, -190}, {83, 83, 812}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 813}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 814}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 65, 815}, {66, 122, -37}, },
            {{48, 72, -31}, {73, 73, 816}, {74, 122, -234}, },
            {{48, 81, -209}, {82, 82, 817}, {83, 122, -32}, },
            {{48, 66, -213}, {67, 67, 818}, {68, 122, -215}, },
            {{48, 68, -28}, {69, 69, 819}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 48, 186}, {49, 49, 820}, {50, 122, -345}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{84, 84, 821}, },
            {{79, 79, 822}, },
            {{69, 69, 823}, },
            {{84, 84, 824}, },
            {{73, 73, 825}, },
            {{73, 73, 826}, },
            {{73, 73, 827}, },
            {},
            {},
            {},
            {{83, 83, 828}, },
            {{73, 73, 829}, },
            {{78, 78, 830}, },
            {{80, 80, 831}, },
            {{79, 79, 832}, },
            {{82, 82, 833}, },
            {{84, 84, 834}, },
            {{83, 83, 835}, },
            {{73, 73, 836}, },
            {{85, 85, 837}, },
            {{69, 69, 838}, },
            {{95, 95, 839}, },
            {{116, 116, 840}, },
            {{114, 114, 841}, },
            {{48, 90, -33}, {95, 95, 842}, {97, 122, 192}, },
            {{48, 77, -43}, {78, 78, 843}, {79, 122, -34}, },
            {{48, 90, -33}, {95, 95, 844}, {97, 122, 192}, },
            {{48, 82, -190}, {83, 83, 845}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 846}, {79, 122, -34}, },
            {{48, 57, 186}, {65, 87, 187}, {88, 88, 847}, {89, 122, -31}, },
            {{48, 78, -196}, {79, 79, 848}, {80, 122, -28}, },
            {{48, 78, -196}, {79, 79, 849}, {80, 122, -28}, },
            {{48, 82, -190}, {83, 83, 850}, {84, 122, -27}, },
            {{48, 83, -202}, {84, 84, 851}, {85, 122, -202}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 852}, {84, 89, 187}, {90, 90, 853}, {95, 122, -27}, },
            {{48, 83, -202}, {84, 84, 854}, {85, 122, -202}, },
            {{48, 68, -28}, {69, 69, 855}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 856}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 857}, {70, 122, -205}, },
            {{48, 77, -43}, {78, 78, 858}, {79, 122, -34}, },
            {{48, 66, -213}, {67, 67, 859}, {68, 122, -215}, },
            {{48, 75, -207}, {76, 76, 860}, {77, 122, -207}, },
            {{48, 57, 186}, {65, 65, 861}, {66, 122, -37}, },
            {{48, 66, -213}, {67, 67, 862}, {68, 122, -215}, },
            {{48, 82, -190}, {83, 83, 863}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{95, 95, 864}, },
            {{78, 78, 865}, },
            {{95, 95, 866}, },
            {{83, 83, 867}, },
            {{78, 78, 868}, },
            {{79, 79, 869}, },
            {{79, 79, 870}, },
            {},
            {{83, 83, 871}, },
            {{84, 84, 872}, },
            {{69, 69, 873}, },
            {{78, 78, 874}, },
            {{78, 78, 875}, },
            {{69, 69, 876}, },
            {},
            {{69, 69, 877}, },
            {{84, 84, 878}, },
            {{83, 83, 879}, },
            {{112, 112, 880}, {115, 115, 881}, },
            {{101, 101, 882}, },
            {{101, 101, 883}, },
            {{48, 66, -213}, {67, 67, 884}, {68, 85, 187}, {86, 86, 885}, {87, 122, -213}, },
            {{48, 82, -190}, {83, 83, 886}, {84, 122, -27}, },
            {{48, 66, -213}, {67, 67, 887}, {68, 85, 187}, {86, 86, 888}, {87, 122, -213}, },
            {{48, 122, -33}, },
            {{48, 83, -202}, {84, 84, 889}, {85, 122, -202}, },
            {{48, 57, 186}, {65, 65, 890}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 891}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 892}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 57, 186}, {65, 65, 893}, {66, 122, -37}, },
            {{48, 57, 186}, {65, 65, 894}, {66, 122, -37}, },
            {{48, 57, 186}, {65, 65, 895}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 81, -209}, {82, 82, 896}, {83, 122, -32}, },
            {{48, 82, -190}, {83, 83, 897}, {84, 122, -27}, },
            {{48, 82, -190}, {83, 83, 898}, {84, 122, -27}, },
            {{48, 83, -202}, {84, 84, 899}, {85, 122, -202}, },
            {{48, 71, -42}, {72, 72, 900}, {73, 122, -45}, },
            {{48, 122, -33}, },
            {{48, 75, -207}, {76, 76, 901}, {77, 122, -207}, },
            {{48, 68, -28}, {69, 69, 902}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{67, 67, 903}, {86, 86, 904}, },
            {{83, 83, 905}, },
            {{67, 67, 906}, {86, 86, 907}, },
            {},
            {{84, 84, 908}, },
            {{78, 78, 909}, },
            {{78, 78, 910}, },
            {{65, 65, 911}, },
            {},
            {{82, 82, 912}, },
            {{83, 83, 913}, },
            {},
            {},
            {{83, 83, 914}, },
            {{73, 73, 915}, },
            {},
            {{114, 114, 916}, },
            {{117, 117, 917}, },
            {{95, 95, 918}, },
            {{100, 100, 919}, },
            {{48, 78, -196}, {79, 79, 920}, {80, 122, -28}, },
            {{48, 57, 186}, {65, 65, 921}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -196}, {79, 79, 922}, {80, 122, -28}, },
            {{48, 57, 186}, {65, 65, 923}, {66, 122, -37}, },
            {{48, 82, -190}, {83, 83, 924}, {84, 122, -27}, },
            {{48, 76, -363}, {77, 77, 925}, {78, 122, -369}, },
            {{48, 82, -190}, {83, 83, 926}, {84, 122, -27}, },
            {{48, 90, -33}, {95, 95, 927}, {97, 122, 192}, },
            {{48, 83, -202}, {84, 84, 928}, {85, 122, -202}, },
            {{48, 83, -202}, {84, 84, 929}, {85, 122, -202}, },
            {{48, 83, -202}, {84, 84, 930}, {85, 122, -202}, },
            {{48, 57, 186}, {65, 65, 931}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 932}, {74, 122, -234}, },
            {{48, 75, -207}, {76, 76, 933}, {77, 122, -207}, },
            {{48, 82, -190}, {83, 83, 934}, {84, 122, -27}, },
            {{79, 79, 935}, },
            {{65, 65, 936}, },
            {},
            {{79, 79, 937}, },
            {{65, 65, 938}, },
            {{83, 83, 939}, },
            {{83, 83, 940}, },
            {},
            {{84, 84, 941}, },
            {{65, 65, 942}, },
            {},
            {},
            {{79, 79, 943}, },
            {{101, 101, 944}, },
            {{98, 98, 945}, },
            {{105, 105, 946}, },
            {{105, 105, 947}, },
            {{48, 77, -43}, {78, 78, 948}, {79, 122, -34}, },
            {{48, 81, -209}, {82, 82, 949}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 950}, {79, 122, -34}, },
            {{48, 81, -209}, {82, 82, 951}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 79, -206}, {80, 80, 952}, {81, 122, -200}, },
            {{48, 122, -33}, },
            {{48, 81, -209}, {82, 82, 953}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 954}, {74, 122, -234}, },
            {{48, 72, -31}, {73, 73, 955}, {74, 122, -234}, },
            {{48, 72, -31}, {73, 73, 956}, {74, 122, -234}, },
            {{48, 83, -202}, {84, 84, 957}, {85, 122, -202}, },
            {{48, 77, -43}, {78, 78, 958}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -190}, {83, 83, 959}, {84, 122, -27}, },
            {{78, 78, 960}, },
            {{82, 82, 961}, },
            {{78, 78, 962}, },
            {{82, 82, 963}, },
            {},
            {},
            {{73, 73, 964}, },
            {{84, 84, 965}, },
            {{78, 78, 966}, },
            {{100, 100, 967}, },
            {{115, 115, 968}, },
            {{100, 100, 969}, },
            {{99, 99, 970}, },
            {{48, 82, -190}, {83, 83, 971}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 972}, {74, 122, -234}, },
            {{48, 82, -190}, {83, 83, 973}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 974}, {74, 122, -234}, },
            {{48, 75, -207}, {76, 76, 975}, {77, 122, -207}, },
            {{48, 84, -233}, {85, 85, 976}, {86, 122, -40}, },
            {{48, 78, -196}, {79, 79, 977}, {80, 122, -28}, },
            {{48, 78, -196}, {79, 79, 978}, {80, 122, -28}, },
            {{48, 78, -196}, {79, 79, 979}, {80, 122, -28}, },
            {{48, 72, -31}, {73, 73, 980}, {74, 122, -234}, },
            {{48, 68, -28}, {69, 69, 981}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{83, 83, 982}, },
            {{73, 73, 983}, },
            {{83, 83, 984}, },
            {{73, 73, 985}, },
            {{79, 79, 986}, },
            {{73, 73, 987}, },
            {},
            {{105, 105, 988}, },
            {{116, 116, 989}, },
            {{101, 101, 990}, },
            {{97, 97, 991}, },
            {{48, 83, -202}, {84, 84, 992}, {85, 122, -202}, },
            {{48, 57, 186}, {65, 65, 993}, {66, 122, -37}, },
            {{48, 83, -202}, {84, 84, 994}, {85, 122, -202}, },
            {{48, 57, 186}, {65, 65, 995}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 996}, {70, 122, -205}, },
            {{48, 75, -207}, {76, 76, 997}, {77, 122, -207}, },
            {{48, 77, -43}, {78, 78, 998}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 999}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 1000}, {79, 122, -34}, },
            {{48, 78, -196}, {79, 79, 1001}, {80, 122, -28}, },
            {{48, 122, -33}, },
            {{84, 84, 1002}, },
            {{65, 65, 1003}, },
            {{84, 84, 1004}, },
            {{65, 65, 1005}, },
            {{78, 78, 1006}, },
            {{79, 79, 1007}, },
            {{99, 99, 1008}, },
            {{105, 105, 1009}, },
            {{110, 110, 1010}, },
            {{116, 116, 1011}, },
            {{48, 57, 186}, {65, 65, 1012}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 1013}, {67, 90, 187}, {95, 122, -27}, },
            {{48, 57, 186}, {65, 65, 1014}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 1015}, {67, 122, -995}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 1016}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 1017}, {79, 122, -34}, },
            {{65, 65, 1018}, },
            {{66, 66, 1019}, },
            {{65, 65, 1020}, },
            {{66, 66, 1021}, },
            {},
            {{78, 78, 1022}, },
            {{97, 97, 1023}, },
            {{116, 116, 1024}, },
            {{116, 116, 1025}, },
            {{101, 101, 1026}, },
            {{48, 77, -43}, {78, 78, 1027}, {79, 122, -34}, },
            {{48, 75, -207}, {76, 76, 1028}, {77, 122, -207}, },
            {{48, 77, -43}, {78, 78, 1029}, {79, 122, -34}, },
            {{48, 75, -207}, {76, 76, 1030}, {77, 122, -207}, },
            {{48, 82, -190}, {83, 83, 1031}, {84, 122, -27}, },
            {{48, 82, -190}, {83, 83, 1032}, {84, 122, -27}, },
            {{78, 78, 1033}, },
            {{76, 76, 1034}, },
            {{78, 78, 1035}, },
            {{76, 76, 1036}, },
            {{83, 83, 1037}, },
            {{116, 116, 1038}, },
            {{117, 117, 1039}, },
            {{105, 105, 1040}, },
            {},
            {{48, 83, -202}, {84, 84, 1041}, {85, 122, -202}, },
            {{48, 68, -28}, {69, 69, 1042}, {70, 122, -205}, },
            {{48, 83, -202}, {84, 84, 1043}, {85, 122, -202}, },
            {{48, 68, -28}, {69, 69, 1044}, {70, 122, -205}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{84, 84, 1045}, },
            {{69, 69, 1046}, },
            {{84, 84, 1047}, },
            {{69, 69, 1048}, },
            {},
            {{101, 101, 1049}, },
            {{116, 116, 1050}, },
            {{102, 102, 1051}, },
            {{48, 82, -190}, {83, 83, 1052}, {84, 122, -27}, },
            {{48, 82, -190}, {83, 83, 1053}, {84, 122, -27}, },
            {{48, 82, -190}, {83, 83, 1054}, {84, 122, -27}, },
            {{48, 82, -190}, {83, 83, 1055}, {84, 122, -27}, },
            {{83, 83, 1056}, },
            {{83, 83, 1057}, },
            {{83, 83, 1058}, },
            {{83, 83, 1059}, },
            {{65, 90, 1060}, {97, 122, 1061}, },
            {{105, 105, 1062}, },
            {{105, 105, 1063}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {},
            {},
            {},
            {},
            {{65, 122, -1051}, },
            {{65, 122, -1051}, },
            {{111, 111, 1064}, },
            {{101, 101, 1065}, },
            {{110, 110, 1066}, },
            {{114, 114, 1067}, },
            {{65, 90, 1068}, {97, 122, 1069}, },
            {{65, 90, 1070}, {97, 122, 1071}, },
            {{65, 122, -1068}, },
            {{65, 122, -1068}, },
            {{65, 122, -1069}, },
            {{65, 122, -1069}, },
        }
        { // SHEBANG
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 34, 3}, {35, 35, 4}, {36, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 5}, {11, 12, 5}, {14, 32, 5}, {127, 160, 5}, {8206, 8207, 5}, {8232, 8233, 5}, },
            {},
            {},
            {{33, 33, 6}, },
            {{0, 8233, -3}, },
            {},
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // PRAGMA
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {34, 34, 3}, {42, 42, 4}, {65, 90, 5}, {97, 98, 6}, {99, 99, 7}, {100, 100, 8}, {101, 101, 6}, {102, 102, 9}, {103, 103, 10}, {104, 104, 6}, {105, 105, 11}, {106, 107, 6}, {108, 108, 12}, {109, 109, 6}, {110, 110, 13}, {111, 114, 6}, {115, 115, 14}, {116, 116, 6}, {117, 117, 15}, {118, 122, 6}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 8233, -2}, },
            {},
            {{0, 33, 16}, {34, 34, 17}, {35, 65535, 16}, },
            {{47, 47, 18}, },
            {{48, 57, 19}, {65, 90, 20}, {95, 95, 21}, {97, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 95, -7}, {97, 110, 22}, {111, 111, 23}, {112, 122, 22}, },
            {{48, 95, -7}, {97, 100, 22}, {101, 101, 24}, {102, 122, 22}, },
            {{48, 95, -7}, {97, 104, 22}, {105, 105, 25}, {106, 122, 22}, },
            {{48, 100, -10}, {101, 101, 26}, {102, 122, 22}, },
            {{48, 95, -7}, {97, 109, 22}, {110, 110, 27}, {111, 122, 22}, },
            {{48, 95, -7}, {97, 97, 28}, {98, 122, 22}, },
            {{48, 100, -10}, {101, 101, 29}, {102, 122, 22}, },
            {{48, 95, -7}, {97, 120, 22}, {121, 121, 30}, {122, 122, 22}, },
            {{48, 109, -13}, {110, 110, 31}, {111, 122, 22}, },
            {{0, 65535, -5}, },
            {},
            {},
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 109, -13}, {110, 110, 32}, {111, 122, 22}, },
            {{48, 95, -7}, {97, 114, 22}, {115, 115, 33}, {116, 122, 22}, },
            {{48, 95, -7}, {97, 107, 22}, {108, 108, 34}, {109, 122, 22}, },
            {{48, 109, -13}, {110, 110, 35}, {111, 122, 22}, },
            {{48, 95, -7}, {97, 101, 22}, {102, 102, 36}, {103, 122, 22}, },
            {{48, 95, -7}, {97, 97, 22}, {98, 98, 37}, {99, 122, 22}, },
            {{48, 95, -7}, {97, 118, 22}, {119, 119, 38}, {120, 122, 22}, },
            {{48, 95, -7}, {97, 108, 22}, {109, 109, 39}, {110, 122, 22}, },
            {{48, 104, -11}, {105, 105, 40}, {106, 122, 22}, },
            {{48, 95, -7}, {97, 117, 22}, {118, 118, 41}, {119, 122, 22}, },
            {{48, 95, -7}, {97, 98, 22}, {99, 99, 42}, {100, 122, 22}, },
            {{48, 100, -10}, {101, 101, 43}, {102, 122, 22}, },
            {{48, 100, -10}, {101, 101, 44}, {102, 122, 22}, },
            {{48, 100, -10}, {101, 101, 45}, {102, 122, 22}, },
            {{48, 100, -10}, {101, 101, 46}, {102, 122, 22}, },
            {{48, 90, -7}, {95, 95, 47}, {97, 122, 22}, },
            {{48, 97, -30}, {98, 98, 48}, {99, 122, 22}, },
            {{48, 95, -7}, {97, 115, 22}, {116, 116, 49}, {117, 122, 22}, },
            {{48, 100, -10}, {101, 101, 50}, {102, 122, 22}, },
            {{48, 95, -7}, {97, 113, 22}, {114, 114, 51}, {115, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 113, -44}, {114, 114, 52}, {115, 122, 22}, },
            {{48, 113, -44}, {114, 114, 53}, {115, 122, 22}, },
            {{48, 107, -27}, {108, 108, 54}, {109, 122, 22}, },
            {{48, 95, -7}, {97, 116, 22}, {117, 117, 55}, {118, 122, 22}, },
            {{48, 110, -9}, {111, 111, 56}, {112, 122, 22}, },
            {{48, 90, -7}, {95, 95, 57}, {97, 122, 22}, },
            {{48, 113, -44}, {114, 114, 58}, {115, 122, 22}, },
            {{48, 104, -11}, {105, 105, 59}, {106, 122, 22}, },
            {{48, 95, -7}, {97, 97, 60}, {98, 122, 22}, },
            {{48, 113, -44}, {114, 114, 61}, {115, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 109, -13}, {110, 110, 62}, {111, 122, 22}, },
            {{48, 107, -27}, {108, 108, 63}, {109, 122, 22}, },
            {{48, 95, -7}, {97, 97, 64}, {98, 122, 22}, },
            {{48, 114, -26}, {115, 115, 65}, {116, 122, 22}, },
            {{48, 95, -7}, {97, 111, 22}, {112, 112, 66}, {113, 122, 22}, },
            {{48, 115, -42}, {116, 116, 67}, {117, 122, 22}, },
            {{48, 100, -10}, {101, 101, 68}, {102, 122, 22}, },
            {{48, 104, -11}, {105, 105, 69}, {106, 122, 22}, },
            {{48, 104, -11}, {105, 105, 70}, {106, 122, 22}, },
            {{48, 107, -27}, {108, 108, 71}, {109, 122, 22}, },
            {{48, 104, -11}, {105, 105, 72}, {106, 122, 22}, },
            {{48, 115, -42}, {116, 116, 73}, {117, 122, 22}, },
            {{48, 100, -10}, {101, 101, 74}, {102, 122, 22}, },
            {{48, 95, -7}, {97, 99, 22}, {100, 100, 75}, {101, 122, 22}, },
            {{48, 115, -42}, {116, 116, 76}, {117, 122, 22}, },
            {{48, 98, -35}, {99, 99, 77}, {100, 122, 22}, },
            {{48, 104, -11}, {105, 105, 78}, {106, 122, 22}, },
            {{48, 110, -9}, {111, 111, 79}, {112, 122, 22}, },
            {{48, 104, -11}, {105, 105, 80}, {106, 122, 22}, },
            {{48, 99, -70}, {100, 100, 81}, {101, 122, 22}, },
            {{48, 90, -7}, {95, 95, 82}, {97, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 95, -7}, {97, 97, 83}, {98, 122, 22}, },
            {{48, 109, -13}, {110, 110, 84}, {111, 122, 22}, },
            {{48, 110, -9}, {111, 111, 85}, {112, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 116, -49}, {117, 117, 86}, {118, 122, 22}, },
            {{48, 114, -26}, {115, 115, 87}, {116, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 109, -13}, {110, 110, 88}, {111, 122, 22}, },
            {{48, 109, -13}, {110, 110, 89}, {111, 122, 22}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 104, -11}, {105, 105, 90}, {106, 122, 22}, },
            {{48, 115, -42}, {116, 116, 91}, {117, 122, 22}, },
            {{48, 122, -7}, },
        }
        { // DESCRIPTION
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {},
            {},
        }
        { // UNIT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {34, 34, 3}, {42, 42, 4}, {65, 90, 5}, {97, 122, 6}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 8233, -2}, },
            {},
            {{0, 33, 7}, {34, 34, 8}, {35, 65535, 7}, },
            {{47, 47, 9}, },
            {{48, 57, 10}, {65, 90, 11}, {95, 95, 12}, {97, 122, 13}, },
            {{48, 122, -7}, },
            {{0, 65535, -5}, },
            {},
            {},
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 262, 262, 26, -1, 27, 28, 29, 30, 31, 32, 33, 34, 36, 39, 40, 44, 47, 259, 259, 55, 58, 59, 70, 73, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 154, 52, 155, 158, 261, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 214, 216, 215, 221, 185, -1, 34, 47, 29, 45, -1, 124, 130, 112, 63, 54, 41, 157, 61, 42, 75, 218, 72, 68, 37, 62, 43, 26, 27, 213, 55, 48, 129, 141, 40, 217, 30, 186, 53, 156, 221, 51, 67, 79, 65, 50, 64, 49, 78, 144, 102, 113, 145, 60, 158, 220, 219, 66, 69, 38, 74, 77, 66, 220, 222, 223, 224, 60, -1, 25, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 35, -1, -1, -1, 43, -1, -1, -1, 46, 45, 20, 3, 48, -1, 51, 53, -1, -1, 56, 57, 56, 60, 62, 64, -1, 67, 69, -1, 71, 72, -1, -1, 78, 79, -1, 254, 254, 254, 254, 254, 254, 254, 85, 254, 254, 254, 254, 254, 96, 254, 254, 254, 254, 254, 254, 254, 254, 254, 105, 254, 108, 254, 254, 254, 254, 254, 254, 126, 254, 128, 129, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 156, -1, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 173, 254, 254, 254, 254, 254, 254, 254, 254, 254, 186, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, -1, 219, 217, -1, -1, 46, 221, 125, 125, 131, 131, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 37, 41, 4, 3, 3, 49, -1, 54, 260, 63, 61, -1, 65, 66, -1, 68, 74, 75, 254, 82, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 100, 254, 254, 254, 254, 103, 254, 254, 254, 254, 254, 111, 254, 115, 254, 254, 254, 254, 254, 122, 254, 130, 132, 254, 254, 254, 254, 254, 140, 254, 254, 254, 254, 254, 254, 254, 254, 148, 254, 254, 157, 254, 254, 160, 254, 254, 254, 254, 254, 168, 254, 254, 171, 254, 254, 254, 254, 254, 254, 254, 181, 182, 254, 184, 185, 254, 254, 254, 254, 194, 195, 196, 197, 254, 199, 254, 254, 205, 254, 254, 254, 254, 210, 254, 254, 218, 220, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 38, 42, 50, 223, 222, 76, 77, 254, 254, 254, 87, 89, 254, 254, 254, 254, 254, 254, 254, 98, 254, 254, 254, 254, 254, 104, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 123, 254, 254, 131, 254, 254, 254, 254, 137, 254, 139, 254, 254, 254, 143, 144, 254, 146, 254, 254, 151, 254, 254, 254, 254, 161, 254, 163, 254, 166, 254, 254, 254, 254, 254, 254, 176, 254, 179, 180, 254, 187, 254, 189, 254, 191, 192, 193, 254, 200, 202, 203, 204, 254, 254, 208, 209, 211, 254, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 248, 249, -1, 250, -1, -1, -1, -1, -1, 224, 254, 254, 86, 254, 254, 254, 254, 254, 254, 254, 99, 254, 254, 254, 102, 254, 254, 254, 254, 254, 254, 254, 113, 254, 254, 254, 254, 254, 118, 254, 254, 254, 254, 254, 254, 254, 254, 141, 254, 254, 145, 254, 254, 152, 153, 159, 254, 162, 254, 167, 254, 170, 172, 174, 175, 177, 254, 254, 254, 254, 198, 201, 254, 254, 212, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 254, 83, 90, 254, 254, 254, 254, 254, 254, 97, 127, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 120, 121, 254, 254, 254, 254, 254, 254, 254, 254, 138, 142, 119, 147, 254, 254, 88, 254, 169, 254, 183, 254, 190, 206, 254, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 252, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, 254, 254, 101, 254, 254, 107, 254, 254, 112, 254, 254, 117, 124, 254, 254, 254, 254, 135, 254, 254, 254, 254, 254, 149, 164, 178, 188, 207, -1, -1, -1, -1, -1, -1, -1, 239, 228, 240, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 109, 254, 254, 254, 125, 254, 133, 254, 254, 254, 254, 254, 254, 254, 165, -1, -1, -1, -1, -1, -1, -1, 241, -1, -1, -1, -1, -1, -1, 246, -1, -1, -1, -1, -1, -1, 254, 254, 254, 93, 254, 254, 254, 254, 225, 254, 254, 254, 114, 254, 254, 254, 254, 254, 254, 254, 254, 150, -1, -1, -1, 235, -1, -1, -1, -1, 243, -1, -1, 253, 227, -1, -1, 251, -1, -1, -1, -1, 254, 254, 84, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 127, 134, 136, 254, 254, 254, -1, -1, 232, -1, -1, -1, 238, 226, -1, -1, 245, 247, -1, -1, -1, -1, -1, 254, 254, 254, 254, 94, 254, 95, 254, 254, 254, 254, 254, 254, 254, 254, -1, -1, -1, -1, 236, 237, -1, -1, -1, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, -1, -1, -1, -1, -1, -1, 229, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, 106, 110, 110, 254, -1, -1, -1, -1, 242, -1, -1, -1, -1, -1, 254, 254, 254, 254, 254, 254, -1, -1, -1, -1, -1, -1, -1, -1, 258, 254, 254, 254, 254, 254, 116, -1, -1, -1, -1, 244, -1, -1, -1, 254, 254, 254, 254, -1, -1, -1, -1, 256, -1, -1, 80, 81, 91, 92, 230, 231, 233, 234, 256, 256, -1, -1, -1, -1, 255, 257, 255, 255, 257, 257, },
        // SHEBANG
        {-1, 2, 1, 2, 2, 262, 0, },
        // COMMENT
        {22, 22, 22, 22, 23, 24, 21, },
        // PRAGMA
        {-1, 262, 262, -1, -1, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, -1, 16, 5, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 14, 13, 16, 16, 16, 16, 16, 6, 16, 16, 16, 16, 12, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 7, 11, 16, 16, 16, 10, 16, 16, 15, 16, 16, 9, 14, 16, 16, 8, },
        // DESCRIPTION
        {17, 17, 17, 17, 23, 24, 21, },
        // UNIT
        {-1, 262, 262, -1, -1, 19, 19, -1, 18, 5, 19, 19, 19, 19, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State SHEBANG = new State(1);
        public final static State COMMENT = new State(2);
        public final static State PRAGMA = new State(3);
        public final static State DESCRIPTION = new State(4);
        public final static State UNIT = new State(5);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
